# Collections Module Demos

This directory contains comprehensive demonstrations of the `collections` module functionality.

## Demo Files

1. `01_basic_file_operations.py` - Basic file operations using File class
2. `02_directory_operations.py` - Directory manipulation and traversal
3. `03_recycle_bin.py` - RecycleBin usage and management
4. `04_file_creators.py` - Creating dummy files of various types
5. `05_os_utils.py` - Advanced OS operations and utilities
6. `06_file_system_events.py` - File system monitoring and events
7. `07_advanced_features.py` - Advanced features and batch operations

## Running the Demos

Each demo file can be run independently. Start with basic demos and progress to more advanced ones:

```bash
python 01_basic_file_operations.py
python 02_directory_operations.py
# ... and so on
```

## Features Demonstrated

### Basic Operations

- File creation and manipulation
- Directory traversal and management
- File metadata and statistics

### Advanced Features

- Recycle bin operations
- File system monitoring
- Batch processing
- Secure file operations

### Utilities

- Dummy file creation
- File type detection
- Directory watching
- Operation logging
