# EnumRegistry Demos

This directory contains comprehensive examples demonstrating the features and capabilities of the True-Core EnumRegistry
module.

## Demo Files

1. **01_basic_usage.py**
    - Basic EnumRegistry creation
    - Working with metadata
    - Member access methods
    - Basic enumeration operations

2. **02_operations.py**
    - Arithmetic operations (add, subtract, intersect)
    - Filtering operations
    - Value analysis and statistics
    - Duplicate detection

3. **03_advanced_features.py**
    - Decorator usage
    - Serialization features
    - Advanced filtering
    - Conflict detection
    - Debug utilities

## Features Demonstrated

- Registry creation and management
- Metadata handling
- Member operations and filtering
- Value analysis and statistics
- Serialization and debugging
- Conflict detection
- Advanced filtering capabilities

## Requirements

- Python 3.8+
- true-core library

## Running the Demos

Each demo file can be run independently:

```bash
python 01_basic_usage.py
python 02_operations.py
python 03_advanced_features.py
```

## Notes

- All demos include detailed comments explaining each operation
- Examples progress from basic to advanced usage
- Each file focuses on specific aspects of the EnumRegistry module
- Real-world use cases are included where applicable
