# EnumToolkits Demos

This directory contains comprehensive examples demonstrating the features and capabilities of the True-Core
enums_toolkits module.

## Demo Files

1. **01_basic_enums.py**
    - Specialized enum types (ByteEnum, FloatEnum, etc.)
    - Collection-based enums (DictEnum, SetEnum, etc.)
    - Type validation
    - Basic enum operations

2. **02_metadata_and_serialization.py**
    - Metadata decorator usage
    - Custom metadata configuration
    - Serialization features
    - JSON and dictionary conversion

3. **03_dynamic_enums.py**
    - Dynamic enum creation
    - Runtime member manipulation
    - Converting from regular enums
    - Error handling

4. **04_iterable_enums.py**
    - Iterable enum types
    - Iterator enum types
    - Generator enum types
    - Combined usage patterns

## Features Demonstrated

- Specialized enum types
- Metadata handling
- Serialization capabilities
- Dynamic enum manipulation
- Iterator and generator support
- Type validation
- Error handling

## Requirements

- Python 3.8+
- true-core library

## Running the Demos

Each demo file can be run independently:

```bash
python 01_basic_enums.py
python 02_metadata_and_serialization.py
python 03_dynamic_enums.py
python 04_iterable_enums.py
```

## Notes

- All demos include detailed comments explaining each operation
- Examples progress from basic to advanced usage
- Each file focuses on specific aspects of the enums_toolkits module
- Real-world use cases are included where applicable
